/[gentoo-x86]/eclass/elisp-common.eclass
Gentoo

Diff of /eclass/elisp-common.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.7 Revision 1.27
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/elisp-common.eclass,v 1.7 2004/06/25 00:39:48 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/elisp-common.eclass,v 1.27 2007/08/27 19:41:03 ulm Exp $
4# 4#
5# Copyright 2007 Christian Faulhammer <opfer@gentoo.org>
5# Copyright 2002-2003 Matthew Kennedy <mkennedy@gentoo.org> 6# Copyright 2002-2004 Matthew Kennedy <mkennedy@gentoo.org>
7# Copyright 2004-2005 Mamoru Komachi <usata@gentoo.org>
6# Copyright 2003 Jeremy Maitin-Shepard <jbms@attbi.com> 8# Copyright 2003 Jeremy Maitin-Shepard <jbms@attbi.com>
9# Copyright 2007 Ulrich Mueller <ulm@gentoo.org>
7# 10#
8# This is not an eclass, but it does provide emacs-related 11# @ECLASS: elisp-common.eclass
9# installation utilities. 12# @MAINTAINER:
10 13# Feel free to contact the Emacs team through emacs@gentoo.org if you have
11ECLASS=elisp-common 14# problems, suggestions or questions.
12INHERITED="$INHERITED $ECLASS" 15# @BLURB: Emacs-related installation utilities
16# @DESCRIPTION:
17#
18# Usually you want to use this eclass for (optional) GNU Emacs support of
19# your package. This is NOT for XEmacs!
20#
21# Many of the steps here are sometimes done by the build system of your
22# package (especially compilation), so this is mainly for standalone elisp
23# files you gathered from somewhere else.
24#
25# When relying on the emacs USE flag, you need to add
26#
27# emacs? ( virtual/emacs )
28#
29# to your DEPEND/RDEPEND line and use the functions provided here to bring
30# the files to the correct locations.
31#
32# .SS
33# src_compile() usage:
34#
35# An elisp file is compiled by the elisp-compile() function defined here and
36# simply takes the source files as arguments.
37#
38# elisp-compile *.el || die "elisp-compile failed"
39#
40# In the case of interdependent elisp files, you can use the elisp-comp()
41# function which makes sure all files are loadable.
42#
43# elisp-comp *.el || die "elisp-comp failed"
44#
45# Function elisp-make-autoload-file() can be used to generate a file with
46# autoload definitions for the lisp functions. It takes the output file name
47# (default: "${PN}-autoloads.el") and a list of directories (default: working
48# directory) as its arguments. Use of this function requires that the elisp
49# source files contain magic ";;;###autoload" comments. See the Emacs Lisp
50# Reference Manual (node "Autoload") for a detailed explanation.
51#
52# .SS
53# src_install() usage:
54#
55# The resulting compiled files (.elc) should be put in a subdirectory of
56# /usr/share/emacs/site-lisp/ which is named after the first argument
57# of elisp-install(). The following parameters are the files to be put in
58# that directory. Usually the subdirectory should be ${PN}, you can choose
59# something else, but remember to tell elisp-site-file-install() (see below)
60# the change, as it defaults to ${PN}.
61#
62# elisp-install ${PN} *.el *.elc || die "elisp-install failed"
63#
64# To let the Emacs support be activated by Emacs on startup, you need
65# to provide a site file (shipped in ${FILESDIR}) which contains the startup
66# code (have a look in the documentation of your software). Normally this
67# would look like this:
68#
69# ;;; csv-mode site-lisp configuration
70#
71# (add-to-list 'load-path "@SITELISP@")
72# (add-to-list 'auto-mode-alist '("\\.csv\\'" . csv-mode))
73# (autoload 'csv-mode "csv-mode" "Major mode for csv files." t)
74#
75# If your Emacs support files are installed in a subdirectory of
76# /usr/share/emacs/site-lisp/ (which is recommended if more than one file is
77# installed), you need to extend Emacs' load-path as shown in the first
78# non-comment. The elisp-site-file-install() function of this eclass will
79# replace "@SITELISP@" by the actual path.
80#
81# The next line tells Emacs to load the mode opening a file ending with
82# ".csv" and load functions depending on the context and needed features.
83# Be careful though. Commands as "load-library" or "require" bloat the
84# editor as they are loaded on every startup. When having a lot of Emacs
85# support files, users may be annoyed by the start-up time. Also avoid
86# keybindings as they might interfere with the user's settings. Give a hint
87# in pkg_postinst(), which should be enough.
88#
89# The naming scheme for this site file is "[0-9][0-9]*-gentoo.el", where the
90# two digits at the beginning define the loading order. So if you depend on
91# another Emacs package, your site file's number must be higher!
92#
93# Best practice is to define a SITEFILE variable in the global scope of your
94# ebuild (right after DEPEND e.g.):
95#
96# SITEFILE=50${PN}-gentoo.el
97#
98# Which is then installed by
99#
100# elisp-site-file-install "${FILESDIR}/${SITEFILE}"
101#
102# in src_install(). If your subdirectory is not named ${PN}, give the
103# differing name as second argument.
104#
105# .SS
106# pkg_postinst() / pkg_postrm() usage:
107#
108# After that you need to recreate the start-up file of Emacs after emerging
109# and unmerging by using
110#
111# pkg_postinst() {
112# elisp-site-regen
113# }
114#
115# pkg_postrm() {
116# elisp-site-regen
117# }
118#
119# When having optional Emacs support, you should prepend "use emacs &&" to
120# above calls of elisp-site-regen(). Don't use "has_version virtual/emacs"!
121# When unmerging the state of the emacs USE flag is taken from the package
122# database and not from the environment, so it is no problem when you unset
123# USE=emacs between merge and unmerge of a package.
124#
125# .SS
126# Miscellaneous functions:
127#
128# elisp-emacs-version() outputs the version of the currently active Emacs.
13 129
14SITELISP=/usr/share/emacs/site-lisp 130SITELISP=/usr/share/emacs/site-lisp
131SITEFILE=50${PN}-gentoo.el
132
133# @FUNCTION: elisp-compile
134# @USAGE: <list of elisp files>
135# @DESCRIPTION:
136# Byte-compile Emacs Lisp files.
15 137
16elisp-compile() { 138elisp-compile() {
17 /usr/bin/emacs --batch -f batch-byte-compile --no-site-file --no-init-file $* 139 einfo "Compiling GNU Emacs Elisp files ..."
140 /usr/bin/emacs -batch -q --no-site-file -f batch-byte-compile $*
18} 141}
142
143# @FUNCTION: elisp-emacs-version
144# @DESCRIPTION:
145# Output version of currently active Emacs.
146
147elisp-emacs-version() {
148 # The following will work for at least versions 18-22.
149 echo "(princ emacs-version)" >"${T}"/emacs-version.el
150 /usr/bin/emacs -batch -q --no-site-file -l "${T}"/emacs-version.el
151}
152
153# @FUNCTION: elisp-make-autoload-file
154# @USAGE: [output file] [list of directories]
155# @DESCRIPTION:
156# Generate a file with autoload definitions for the lisp functions.
157
158elisp-make-autoload-file () {
159 local f="${1:-${PN}-autoloads.el}"
160 shift
161 einfo "Generating autoload file for GNU Emacs ..."
162
163 sed 's/^FF/\f/' >"${f}" <<-EOF
164 ;;; ${f##*/} --- autoloads for ${P}
165
166 ;;; Commentary:
167 ;; Automatically generated by elisp-common.eclass
168 ;; DO NOT EDIT THIS FILE
169
170 ;;; Code:
171 FF
172 ;; Local Variables:
173 ;; version-control: never
174 ;; no-byte-compile: t
175 ;; no-update-autoloads: t
176 ;; End:
177 ;;; ${f##*/} ends here
178 EOF
179
180 /usr/bin/emacs -batch -q --no-site-file \
181 --eval "(setq make-backup-files nil)" \
182 --eval "(setq generated-autoload-file (expand-file-name \"${f}\"))" \
183 -f batch-update-autoloads "${@-.}"
184}
185
186# @FUNCTION: elisp-install
187# @USAGE: <subdirectory> <list of files>
188# @DESCRIPTION:
189# Install files in SITELISP directory.
19 190
20elisp-install() { 191elisp-install() {
21 local subdir=$1 192 local subdir=$1
193 einfo "Installing Elisp files for GNU Emacs support ..."
22 dodir ${SITELISP}/${subdir} 194 dodir "${SITELISP}/${subdir}"
23 insinto ${SITELISP}/${subdir} 195 insinto "${SITELISP}/${subdir}"
24 shift 196 shift
25 doins $@ 197 doins $@
26} 198}
27 199
200# @FUNCTION: elisp-site-file-install
201# @USAGE: <site-init file> [subdirectory]
202# @DESCRIPTION:
203# Install Emacs site-init file in SITELISP directory.
204
28elisp-site-file-install() { 205elisp-site-file-install() {
29 local sitefile=$1 my_pn=${2:-${PN}} 206 local sitefile=$1 my_pn=${2:-${PN}}
207 einfo "Installing site initialisation file for GNU Emacs ..."
30 pushd ${S} 208 pushd "${S}"
31 cp ${sitefile} ${T} 209 cp ${sitefile} "${T}"
32 sed -i "s:@SITELISP@:${SITELISP}/${my_pn}:g" ${T}/$(basename ${sitefile}) 210 sed -i "s:@SITELISP@:${SITELISP}/${my_pn}:g" "${T}/$(basename ${sitefile})"
33 insinto ${SITELISP} 211 insinto ${SITELISP}
34 doins ${T}/$(basename ${sitefile}) 212 doins "${T}/$(basename ${sitefile})" || die "failed to install site file"
35 popd 213 popd
36} 214}
37 215
216# @FUNCTION: elisp-site-regen
217# @DESCRIPTION:
218# Regenerate site-gentoo.el file.
219
38elisp-site-regen() { 220elisp-site-regen() {
221 local sflist sf line
222
39 einfo "Regenerating ${SITELISP}/site-gentoo.el..." 223 einfon "Regenerating ${SITELISP}/site-gentoo.el ..."
40 einfo ""
41 cat <<EOF >${SITELISP}/site-gentoo.el 224 cat <<-EOF >"${T}"/site-gentoo.el
42;;; DO NOT EDIT THIS FILE -- IT IS GENERATED AUTOMATICALLY BY PORTAGE 225 ;;; site-gentoo.el --- site initialisation for Gentoo-installed packages
43;;; -----------------------------------------------------------------
44 226
227 ;;; Commentary:
228 ;; Automatically generated by elisp-common.eclass
229 ;; DO NOT EDIT THIS FILE
230
231 ;;; Code:
232 EOF
233
234 for sf in "${ROOT}${SITELISP}"/[0-9][0-9]*-gentoo.el
235 do
236 [ -r "${sf}" ] || continue
237 sflist="${sflist} $(basename "${sf}")"
238 cat "${sf}" >>"${T}"/site-gentoo.el
239 done
240
241 cat <<-EOF >>"${T}"/site-gentoo.el
242
243 ;;; site-gentoo.el ends here
244 EOF
245
246 if cmp -s "${ROOT}${SITELISP}"/site-gentoo.el "${T}"/site-gentoo.el; then
247 # This prevents outputting unnecessary text when there
248 # was actually no change
249 # A case is a remerge where we have doubled output
250 echo " no changes."
251 else
252 mv "${T}"/site-gentoo.el "${ROOT}${SITELISP}"/site-gentoo.el
253 echo; einfo
254 for sf in ${sflist}; do
255 einfo " Adding ${sf} ..."
256 done
257 while read line; do einfo "${line}"; done <<EOF
258
259All site initialisation for Gentoo-installed packages is added to
260/usr/share/emacs/site-lisp/site-gentoo.el; site-start.el is no longer
261managed by Gentoo. You are responsible for all maintenance of
262site-start.el if there is such a file.
263
264In order for this site initialisation to be loaded for all users
265automatically, you can add a line like this:
266
267 (load "/usr/share/emacs/site-lisp/site-gentoo" nil t)
268
269to /usr/share/emacs/site-lisp/site-start.el. Alternatively, that line
270can be added by individual users to their initialisation files, or for
271greater flexibility, users can select which of the package-specific
272initialisation files in /usr/share/emacs/site-lisp/ to load.
45EOF 273EOF
46 ls ${SITELISP}/[0-9][0-9]*-gentoo.el |sort -n | \
47 while read sf
48 do
49 einfo " Adding $(basename $sf)..."
50 # Great for debugging, too noisy and slow for users though
51# echo "(message \"Loading $sf...\")" >>${SITELISP}/site-start.el
52 cat $sf >>${SITELISP}/site-gentoo.el
53 done
54 while read line; do einfo "${line}"; done <<EOF
55
56All site initialization for Gentoo-installed packages is now added to
57/usr/share/emacs/site-lisp/site-gentoo.el; site-start.el is no longer
58managed by Gentoo. You may want to remove the generated
59site-start.el.
60
61In order for this site initialization to be loaded for all users
62automatically, as was done previously, you can add a line like this:
63
64 (load "/usr/share/emacs/site-lisp/site-gentoo")
65
66to /usr/share/emacs/site-lisp/site-start.el. Alternatively, that line
67can be added by individual users to their initialization files, or for
68greater flexibility, users can select which of the package-specific
69initialization files in /usr/share/emacs/site-lisp to load.
70EOF
71 echo 274 echo
275 fi
72} 276}
73 277
74# The following Emacs Lisp compilation routine is taken from GNU 278# @FUNCTION: elisp-comp
75# autotools. 279# @USAGE: <list of elisp files>
280# @DESCRIPTION:
281# Byte-compile interdependent Emacs Lisp files.
282# Originally taken from GNU autotools.
76 283
77elisp-comp() { 284elisp-comp() {
78# Copyright 1995 Free Software Foundation, Inc. 285 # Copyright 1995 Free Software Foundation, Inc.
79# Franois Pinard <pinard@iro.umontreal.ca>, 1995. 286 # Franรงois Pinard <pinard@iro.umontreal.ca>, 1995.
80#
81# This program is free software; you can redistribute it and/or modify
82# it under the terms of the GNU General Public License as published by
83# the Free Software Foundation; either version 2, or (at your option)
84# any later version.
85#
86# This program is distributed in the hope that it will be useful,
87# but WITHOUT ANY WARRANTY; without even the implied warranty of
88# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
89# GNU General Public License for more details.
90#
91# You should have received a copy of the GNU General Public License
92# along with this program; if not, write to the Free Software
93# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
94
95# As a special exception to the GNU General Public License, if you
96# distribute this file as part of a program that contains a
97# configuration script generated by Autoconf, you may include it under
98# the same distribution terms that you use for the rest of that program.
99
100# This script byte-compiles all `.el' files which are part of its 287 # This script byte-compiles all `.el' files which are part of its
101# arguments, using GNU Emacs, and put the resulting `.elc' files into 288 # arguments, using GNU Emacs, and put the resulting `.elc' files into
102# the current directory, so disregarding the original directories used 289 # the current directory, so disregarding the original directories used
103# in `.el' arguments. 290 # in `.el' arguments.
104# 291 #
105# This script manages in such a way that all Emacs LISP files to 292 # This script manages in such a way that all Emacs LISP files to
106# be compiled are made visible between themselves, in the event 293 # be compiled are made visible between themselves, in the event
107# they require or load-library one another. 294 # they require or load-library one another.
108 295
109 if test $# = 0; then 296 test $# -gt 0 || return 1
110 echo 1>&2 "No files given to $0" 297
111 exit 1
112 else
113 if test -z "$EMACS" || test "$EMACS" = "t"; then 298 if test -z "${EMACS}" || test "${EMACS}" = "t"; then
114 # Value of "t" means we are running in a shell under Emacs. 299 # Value of "t" means we are running in a shell under Emacs.
115 # Just assume Emacs is called "emacs". 300 # Just assume Emacs is called "emacs".
116 EMACS=emacs 301 EMACS=/usr/bin/emacs
117 fi
118
119 tempdir=elc.$$
120 mkdir $tempdir
121 cp $* $tempdir
122 cd $tempdir
123
124 echo "(add-to-list 'load-path \"../\")" > script
125 $EMACS -batch -q --no-site-file --no-init-file -l script -f batch-byte-compile *.el
126 mv *.elc ..
127
128 cd ..
129 rm -fr $tempdir
130 fi 302 fi
131} 303 einfo "Compiling GNU Emacs Elisp files ..."
132 304
133# Local Variables: *** 305 tempdir=elc.$$
134# mode: shell-script *** 306 mkdir ${tempdir}
135# tab-width: 4 *** 307 cp $* ${tempdir}
136# indent-tabs-mode: t *** 308 pushd ${tempdir}
137# End: ***
138 309
310 echo "(add-to-list 'load-path \"../\")" > script
311 ${EMACS} -batch -q --no-site-file --no-init-file -l script \
312 -f batch-byte-compile *.el
313 local status=$?
314 mv *.elc ..
315
316 popd
317 rm -fr ${tempdir}
318 return ${status}
319}

Legend:
Removed from v.1.7  
changed lines
  Added in v.1.27

  ViewVC Help
Powered by ViewVC 1.1.20